JUCE: Line< ValueType > Class Template Reference

JUCE

Public Member Functions | Static Public Member Functions | List of all members
Line< ValueType > Class Template Reference

Represents a line. More...

## Public Member Functions
| Line ()=default
| Creates a line, using (0, 0) as its start and end points. More...
| Line (const Line &)=default
| Creates a copy of another line. More...
| Line (ValueType startX, ValueType startY, ValueType endX, ValueType endY) noexcept
| Creates a line based on the coordinates of its start and end points. More...
| Line (Point< ValueType > startPoint, Point< ValueType > endPoint) noexcept
| Creates a line from its start and end points. More...
Line & | operator= (const Line &)=default
| Copies a line from another one. More...
| ~Line ()=default
| Destructor. More...
ValueType | getStartX () const noexcept
| Returns the x coordinate of the line's start point. More...
ValueType | getStartY () const noexcept
| Returns the y coordinate of the line's start point. More...
ValueType | getEndX () const noexcept
| Returns the x coordinate of the line's end point. More...
ValueType | getEndY () const noexcept
| Returns the y coordinate of the line's end point. More...
Point< ValueType > | getStart () const noexcept
| Returns the line's start point. More...
Point< ValueType > | getEnd () const noexcept
| Returns the line's end point. More...
void | setStart (ValueType newStartX, ValueType newStartY) noexcept
| Changes this line's start point. More...
void | setEnd (ValueType newEndX, ValueType newEndY) noexcept
| Changes this line's end point. More...
void | setStart (const Point< ValueType > newStart) noexcept
| Changes this line's start point. More...
void | setEnd (const Point< ValueType > newEnd) noexcept
| Changes this line's end point. More...
Line | reversed () const noexcept
| Returns a line that is the same as this one, but with the start and end reversed,. More...
void | applyTransform (const AffineTransform &transform) noexcept
| Applies an affine transform to the line's start and end points. More...
ValueType | getLength () const noexcept
| Returns the length of the line. More...
ValueType | getLengthSquared () const noexcept
| Returns the length of the line. More...
bool | isVertical () const noexcept
| Returns true if the line's start and end x coordinates are the same. More...
bool | isHorizontal () const noexcept
| Returns true if the line's start and end y coordinates are the same. More...
Point< ValueType >::FloatType | getAngle () const noexcept
| Returns the line's angle. More...
Line< float > | toFloat () const noexcept
| Casts this line to float coordinates. More...
Line< double > | toDouble () const noexcept
| Casts this line to double coordinates. More...
bool | operator== (Line other) const noexcept
| Compares two lines. More...
bool | operator!= (Line other) const noexcept
| Compares two lines. More...
Point< ValueType > | getIntersection (Line line) const noexcept
| Finds the intersection between two lines. More...
bool | intersects (Line line, Point< ValueType > &intersection) const noexcept
| Finds the intersection between two lines. More...
bool | intersects (Line other) const noexcept
| Returns true if this line intersects another. More...
Point< ValueType > | getPointAlongLine (ValueType distanceFromStart) const noexcept
| Returns the location of the point which is a given distance along this line. More...
Point< ValueType > | getPointAlongLine (ValueType distanceFromStart, ValueType perpendicularDistance) const noexcept
| Returns a point which is a certain distance along and to the side of this line. More...
Point< ValueType > | getPointAlongLineProportionally (typename Point< ValueType >::FloatType proportionOfLength) const noexcept
| Returns the location of the point which is a given distance along this line proportional to the line's length. More...
ValueType | getDistanceFromPoint (Point< ValueType > targetPoint, Point< ValueType > &pointOnLine) const noexcept
| Returns the smallest distance between this line segment and a given point. More...
ValueType | findNearestProportionalPositionTo (Point< ValueType > point) const noexcept
| Finds the point on this line which is nearest to a given point, and returns its position as a proportional position along the line. More...
Point< ValueType > | findNearestPointTo (Point< ValueType > point) const noexcept
| Finds the point on this line which is nearest to a given point. More...
bool | isPointAbove (Point< ValueType > point) const noexcept
| Returns true if the given point lies above this line. More...
Line | withShortenedStart (ValueType distanceToShortenBy) const noexcept
| Returns a shortened copy of this line. More...
Line | withShortenedEnd (ValueType distanceToShortenBy) const noexcept
| Returns a shortened copy of this line. More...

## Static Public Member Functions
static Line | fromStartAndAngle (Point< ValueType > startPoint, ValueType length, ValueType angle) noexcept
| Creates a line from a start point, length and angle. More...

## Detailed Description

### template<typename ValueType>
class Line< ValueType >

Represents a line.

This class contains a bunch of useful methods for various geometric tasks.

The ValueType template parameter should be a primitive type - float or double are what it's designed for. Integer types will work in a basic way, but some methods that perform mathematical operations may not compile, or they may not produce sensible results.

See also
  Point, Rectangle, Path, Graphics::drawLine

## Constructor & Destructor Documentation

## ◆ Line() [1/4]

template<typename ValueType >

Line< ValueType >::Line | ( |  | ) |
| default

Creates a line, using (0, 0) as its start and end points.

## ◆ Line() [2/4]

template<typename ValueType >

Line< ValueType >::Line | ( | const Line< ValueType > & |  | ) |
| default

Creates a copy of another line.

## ◆ Line() [3/4]

template<typename ValueType >

Line< ValueType >::Line | ( | ValueType | startX,
|  | ValueType | startY,
|  | ValueType | endX,
|  | ValueType | endY
| ) |  |
| noexcept

Creates a line based on the coordinates of its start and end points.

## ◆ Line() [4/4]

template<typename ValueType >

Line< ValueType >::Line | ( | Point< ValueType > | startPoint,
|  | Point< ValueType > | endPoint
| ) |  |
| noexcept

Creates a line from its start and end points.

## ◆ ~Line()

template<typename ValueType >

Line< ValueType >::~Line | ( |  | ) |
| default

Destructor.

## Member Function Documentation

## ◆ operator=()

template<typename ValueType >

Line& Line< ValueType >::operator= | ( | const Line< ValueType > & |  | ) |
| default

Copies a line from another one.

## ◆ getStartX()

template<typename ValueType >

ValueType Line< ValueType >::getStartX | ( |  | ) | const
| noexcept

Returns the x coordinate of the line's start point.

## ◆ getStartY()

template<typename ValueType >

ValueType Line< ValueType >::getStartY | ( |  | ) | const
| noexcept

Returns the y coordinate of the line's start point.

## ◆ getEndX()

template<typename ValueType >

ValueType Line< ValueType >::getEndX | ( |  | ) | const
| noexcept

Returns the x coordinate of the line's end point.

## ◆ getEndY()

template<typename ValueType >

ValueType Line< ValueType >::getEndY | ( |  | ) | const
| noexcept

Returns the y coordinate of the line's end point.

## ◆ getStart()

template<typename ValueType >

Point<ValueType> Line< ValueType >::getStart | ( |  | ) | const
| noexcept

Returns the line's start point.

## ◆ getEnd()

template<typename ValueType >

Point<ValueType> Line< ValueType >::getEnd | ( |  | ) | const
| noexcept

Returns the line's end point.

## ◆ setStart() [1/2]

template<typename ValueType >

void Line< ValueType >::setStart | ( | ValueType | newStartX,
|  | ValueType | newStartY
| ) |  |
| noexcept

Changes this line's start point.

## ◆ setEnd() [1/2]

template<typename ValueType >

void Line< ValueType >::setEnd | ( | ValueType | newEndX,
|  | ValueType | newEndY
| ) |  |
| noexcept

Changes this line's end point.

## ◆ setStart() [2/2]

template<typename ValueType >

void Line< ValueType >::setStart | ( | const Point< ValueType > | newStart | ) |
| noexcept

Changes this line's start point.

## ◆ setEnd() [2/2]

template<typename ValueType >

void Line< ValueType >::setEnd | ( | const Point< ValueType > | newEnd | ) |
| noexcept

Changes this line's end point.

## ◆ reversed()

template<typename ValueType >

Line Line< ValueType >::reversed | ( |  | ) | const
| noexcept

Returns a line that is the same as this one, but with the start and end reversed,.

## ◆ applyTransform()

template<typename ValueType >

void Line< ValueType >::applyTransform | ( | const AffineTransform & | transform | ) |
| noexcept

Applies an affine transform to the line's start and end points.

## ◆ getLength()

template<typename ValueType >

ValueType Line< ValueType >::getLength | ( |  | ) | const
| noexcept

Returns the length of the line.

Referenced by Parallelogram< float >::getHeight(), Line< ValueType >::getPointAlongLine(), Parallelogram< float >::getWidth(), Line< ValueType >::withShortenedEnd(), and Line< ValueType >::withShortenedStart().

## ◆ getLengthSquared()

template<typename ValueType >

ValueType Line< ValueType >::getLengthSquared | ( |  | ) | const
| noexcept

Returns the length of the line.

## ◆ isVertical()

template<typename ValueType >

bool Line< ValueType >::isVertical | ( |  | ) | const
| noexcept

Returns true if the line's start and end x coordinates are the same.

## ◆ isHorizontal()

template<typename ValueType >

bool Line< ValueType >::isHorizontal | ( |  | ) | const
| noexcept

Returns true if the line's start and end y coordinates are the same.

## ◆ getAngle()

template<typename ValueType >

Point<ValueType>::FloatType Line< ValueType >::getAngle | ( |  | ) | const
| noexcept

Returns the line's angle.

This value is the number of radians clockwise from the 12 o'clock direction, where the line's start point is considered to be at the centre.

## ◆ fromStartAndAngle()

template<typename ValueType >

static Line Line< ValueType >::fromStartAndAngle | ( | Point< ValueType > | startPoint,
|  | ValueType | length,
|  | ValueType | angle
| ) |  |
| staticnoexcept

Creates a line from a start point, length and angle.

This angle is the number of radians clockwise from the 12 o'clock direction, where the line's start point is considered to be at the centre.

## ◆ toFloat()

template<typename ValueType >

Line<float> Line< ValueType >::toFloat | ( |  | ) | const
| noexcept

Casts this line to float coordinates.

## ◆ toDouble()

template<typename ValueType >

Line<double> Line< ValueType >::toDouble | ( |  | ) | const
| noexcept

Casts this line to double coordinates.

## ◆ operator==()

template<typename ValueType >

bool Line< ValueType >::operator== | ( | Line< ValueType > | other | ) | const
| noexcept

Compares two lines.

## ◆ operator!=()

template<typename ValueType >

bool Line< ValueType >::operator!= | ( | Line< ValueType > | other | ) | const
| noexcept

Compares two lines.

## ◆ getIntersection()

template<typename ValueType >

Point<ValueType> Line< ValueType >::getIntersection | ( | Line< ValueType > | line | ) | const
| noexcept

Finds the intersection between two lines.

Parameters

  line | the line to intersect with

Returns
  the point at which the lines intersect, even if this lies beyond the end of the lines

## ◆ intersects() [1/2]

template<typename ValueType >

bool Line< ValueType >::intersects | ( | Line< ValueType > | line,
|  | Point< ValueType > & | intersection
| ) |  | const
| noexcept

Finds the intersection between two lines.

Parameters

  line | the other line
  intersection | the position of the point where the lines meet (or where they would meet if they were infinitely long) the intersection (if the lines intersect). If the lines are parallel, this will just be set to the position of one of the line's endpoints.

Returns
  true if the line segments intersect; false if they don't. Even if they don't intersect, the intersection coordinates returned will still be valid

## ◆ intersects() [2/2]

template<typename ValueType >

bool Line< ValueType >::intersects | ( | Line< ValueType > | other | ) | const
| noexcept

Returns true if this line intersects another.

## ◆ getPointAlongLine() [1/2]

template<typename ValueType >

Point<ValueType> Line< ValueType >::getPointAlongLine | ( | ValueType | distanceFromStart | ) | const
| noexcept

Returns the location of the point which is a given distance along this line.

Parameters

  distanceFromStart | the distance to move along the line from its start point. This value can be negative or longer than the line itself

See also
  getPointAlongLineProportionally

References Line< ValueType >::getLength().

Referenced by Line< ValueType >::withShortenedEnd(), and Line< ValueType >::withShortenedStart().

## ◆ getPointAlongLine() [2/2]

template<typename ValueType >

Point<ValueType> Line< ValueType >::getPointAlongLine | ( | ValueType | distanceFromStart,
|  | ValueType | perpendicularDistance
| ) |  | const
| noexcept

Returns a point which is a certain distance along and to the side of this line.

This effectively moves a given distance along the line, then another distance perpendicularly to this, and returns the resulting position.

Parameters

  distanceFromStart | the distance to move along the line from its start point. This value can be negative or longer than the line itself
  perpendicularDistance | how far to move sideways from the line. If you're looking along the line from its start towards its end, then a positive value here will move to the right, negative value move to the left.

References juce_hypot().

## ◆ getPointAlongLineProportionally()

template<typename ValueType >

Point<ValueType> Line< ValueType >::getPointAlongLineProportionally | ( | typename Point< ValueType >::FloatType | proportionOfLength | ) | const
| noexcept

Returns the location of the point which is a given distance along this line proportional to the line's length.

Parameters

  proportionOfLength | the distance to move along the line from its start point, in multiples of the line's length. So a value of 0.0 will return the line's start point and a value of 1.0 will return its end point. (This value can be negative or greater than 1.0).

See also
  getPointAlongLine

Referenced by Line< ValueType >::findNearestPointTo().

## ◆ getDistanceFromPoint()

template<typename ValueType >

ValueType Line< ValueType >::getDistanceFromPoint | ( | Point< ValueType > | targetPoint,
|  | Point< ValueType > & | pointOnLine
| ) |  | const
| noexcept

Returns the smallest distance between this line segment and a given point.

So if the point is close to the line, this will return the perpendicular distance from the line; if the point is a long way beyond one of the line's end-point's, it'll return the straight-line distance to the nearest end-point.

pointOnLine receives the position of the point that is found.

Returns
  the point's distance from the line

See also
  getPositionAlongLineOfNearestPoint

## ◆ findNearestProportionalPositionTo()

template<typename ValueType >

ValueType Line< ValueType >::findNearestProportionalPositionTo | ( | Point< ValueType > | point | ) | const
| noexcept

Finds the point on this line which is nearest to a given point, and returns its position as a proportional position along the line.

Returns
  a value 0 to 1.0 which is the distance along this line from the line's start to the point which is nearest to the point passed-in. To turn this number into a position, use getPointAlongLineProportionally().

See also
  getDistanceFromPoint, getPointAlongLineProportionally

References jlimit().

Referenced by Line< ValueType >::findNearestPointTo().

## ◆ findNearestPointTo()

template<typename ValueType >

Point<ValueType> Line< ValueType >::findNearestPointTo | ( | Point< ValueType > | point | ) | const
| noexcept

Finds the point on this line which is nearest to a given point.

See also
  getDistanceFromPoint, findNearestProportionalPositionTo

References Line< ValueType >::findNearestProportionalPositionTo(), and Line< ValueType >::getPointAlongLineProportionally().

## ◆ isPointAbove()

template<typename ValueType >

bool Line< ValueType >::isPointAbove | ( | Point< ValueType > | point | ) | const
| noexcept

Returns true if the given point lies above this line.

The return value is true if the point's y coordinate is less than the y coordinate of this line at the given x (assuming the line extends infinitely in both directions).

## ◆ withShortenedStart()

template<typename ValueType >

Line Line< ValueType >::withShortenedStart | ( | ValueType | distanceToShortenBy | ) | const
| noexcept

Returns a shortened copy of this line.

This will chop off part of the start of this line by a certain amount, (leaving the end-point the same), and return the new line.

References Line< ValueType >::getLength(), Line< ValueType >::getPointAlongLine(), and jmin().

## ◆ withShortenedEnd()

template<typename ValueType >

Line Line< ValueType >::withShortenedEnd | ( | ValueType | distanceToShortenBy | ) | const
| noexcept

Returns a shortened copy of this line.

This will chop off part of the end of this line by a certain amount, (leaving the start-point the same), and return the new line.

References Line< ValueType >::getLength(), Line< ValueType >::getPointAlongLine(), and jmin().

The documentation for this class was generated from the following file:

- juce_Line.h